#include "LibrarySettings.hpp"

namespace CreatureLib::Library {
    struct LibrarySettings::impl {
        level_int_t _maximalLevel;
        uint8_t _maximalAttacks;

    public:
        impl(level_int_t maximalLevel, uint8_t maximalAttacks)
            : _maximalLevel(maximalLevel), _maximalAttacks(maximalAttacks) {}

        [[nodiscard]] inline level_int_t GetMaximalLevel() const noexcept { return _maximalLevel; }

        [[nodiscard]] inline uint8_t GetMaximalAttacks() const noexcept { return _maximalAttacks; }
    };
    LibrarySettings::LibrarySettings(level_int_t maximalLevel, uint8_t maximalAttacks)
        : _impl(new impl(maximalLevel, maximalAttacks)) {}
    LibrarySettings::~LibrarySettings() = default;

    level_int_t LibrarySettings::GetMaximalLevel() const noexcept { return _impl->GetMaximalLevel(); }
    uint8_t LibrarySettings::GetMaximalAttacks() const noexcept { return _impl->GetMaximalAttacks(); }
}